#include "defs.h"
#include "replace.h"

/*DEFHELP #cmd misc REQREPLACE - display replace requester ((c) 1994 by Karl Lukas) */

DEFUSERCMD("reqreplace", 0, 0, void, do_reqreplace, (void),)
{
   int replace = 0;
   extern UBYTE Fstr[], Rstr[];

   strcpy (SearchPattern, Fstr);
   strcpy (ReplacePattern, Rstr);

   if (! OpenReplaceWindow(Ep->win->WScreen))
   {
      if (HandleReplaceIDCMP())
      {
	 replace = 1;
      }
      else
DEFMESSAGE( __operation_cancelled, "Operation cancelled" )
	 title(__operation_cancelled);
      CloseReplaceWindow();
   }
   else
DEFMESSAGE( _REP_cant_open_rep_req, "%s:\nUnable to open replace requester" )
      error (_REP_cant_open_rep_req, av[0]);

   if (replace)
   {
      strcpy(Fstr, SearchPattern);
      strcpy(Rstr, ReplacePattern);

      do_command("nextr");
   }
}

// the following entries ar from "replace.c"
DEFMESSAGE( ___ok, "_OK" )
DEFMESSAGE( ___cancel, "_Cancel" )
DEFMESSAGE( _REP_wintitle, "Replace text" )
DEFMESSAGE( _REP_findlabel,    "   Find" )
DEFMESSAGE( _REP_replacelabel, "Replace" )


#if 0

setmacro kappa 1 (down insline col \$arg1)

newwindow newfile repreq.c

top find `int SetupScreen'       unblock bstart down match bend bdelete
top find `void CloseDownScreen'  unblock bstart down match bend bdelete

top find `int OpenReplaceWindow' findr void (struct Screen *Scr) goto +8
   kappa 9 (if (! (VisualInfo = GetVisualInfo( Scr, TAG_DONE ))))
   kappa 9 (        return( 2L );)
   kappa 1
   kappa 9 (ReplaceLeft = Scr->MouseX - 290;)
   kappa 9 (if (ReplaceLeft < 0) ReplaceLeft = 0;)
   kappa 9 (ReplaceTop = Scr->MouseY - 42 - offy - 7;)
   kappa 9 (if (ReplaceTop < 0) ReplaceTop = 0;)
   kappa 1

top find `int OpenReplaceWindow' down match 3 up
   kappa 9 (GT_SetGadgetAttrs(ReplaceGadgets[GD_search], ReplaceWnd, NULL,)
   kappa 9 (        GTST_String, SearchPattern, TAG_DONE);)
   kappa 9 (GT_SetGadgetAttrs(ReplaceGadgets[GD_replace], ReplaceWnd, NULL,)
   kappa 9 (        GTST_String, ReplacePattern, TAG_DONE);)
   kappa 9 (RefreshGList(ReplaceGList, ReplaceWnd, NULL, Replace_CNT + 1);)
   kappa 9 (        ActivateGadget(ReplaceGadgets[GD_search], ReplaceWnd, NULL);)

top find `void CloseReplaceWindow' down match up
   kappa 9 (if ( VisualInfo ) {)
   kappa 9 (        FreeVisualInfo( VisualInfo );)
   kappa 9 (        VisualInfo = NULL;)
   kappa 9 (})

top find `int HandleReplaceIDCMP' 3 down deline
   kappa 9 (BOOL cancelled = FALSE;)
   kappa 9 (char *strptr;)
   kappa 1
   kappa 9 (while (running))
   kappa 9 ({)
   kappa 9 (        Wait(1L << ReplaceWnd->UserPort->mp_SigBit);)

   ping 1
   unblock find {
       2 down 3 deline 2 up
       block match block
       insline (GT_ReplyIMsg ( m );) down

   kappa 9 (})
   kappa 9 (if (! cancelled))
   kappa 9 ({)
   kappa 9 (    strptr = (char *)GetString(ReplaceGadgets[GD_search]);)
   kappa 9 (    if (strptr))
   kappa 9 (        strcpy(SearchPattern, strptr);)
   kappa 9 (    strptr = (char *)GetString(ReplaceGadgets[GD_replace]);)
   kappa 9 (    if (strptr))
   kappa 9 (        strcpy(ReplacePattern, strptr);)
   kappa 9 (})
   kappa 9 (return(! cancelled);)
   down deline

   indent b .8
   pong 1
   findr ReplaceMsg. m->

   pong 1
   find IDCMP_CLOSEWINDOW: down deline up
   kappa 41 (cancelled = TRUE;)
   kappa 41 (running   = FALSE;)

   pong 1
   find IDCMP_VANILLAKEY: down deline up
   kappa 41 (switch (m->Code))
   kappa 41 ({)
   kappa 41 (    case 'O':)
   kappa 41 (    case 'o':)
   kappa 41 (         running   = FALSE;)
   kappa 41 (         break;)
   kappa 41 (    case 'C':)
   kappa 41 (    case 'c':)
   kappa 41 (         cancelled = TRUE;)
   kappa 41 (         running   = FALSE;)
   kappa 41 (         break;)
   kappa 41 (    default:;)
   kappa 41 (})

   pong 1
   find IDCMP_GADGETUP: down 2 deline up
   kappa 41 (gad = (struct Gadget *)m->IAddress;)
   kappa 41 (switch(gad->GadgetID))
   kappa 41 ({)
   kappa 41 (    case GD_ok:)
   kappa 41 (         done = TRUE;)
   kappa 41 (         break;)
   kappa 41 (    case GD_cancel:)
   kappa 41 (         cancelled = TRUE;)
   kappa 41 (         done = TRUE;)
   kappa 41 (         break;)
   kappa 41 (    case GD_search:)
   kappa 41 (         ActivateGadget(ReplaceGadgets[GD_replace], ReplaceWnd, NULL);)
   kappa 41 (         break;)
   kappa 41 (    case GD_replace:)
   kappa 41 (         strptr = (char *)GetString(ReplaceGadgets[GD_search]);)
   kappa 41 (         /* If Code is 9 the gadget was deactivated with the TAB key */)
   kappa 41 (         if ((strlen(strptr) > 0) && (m->Code != 9)))
   kappa 41 (            done = TRUE;)
   kappa 41 (         else)
   kappa 41 (         ActivateGadget(ReplaceGadgets[GD_search], ReplaceWnd, NULL);)
   kappa 41 (      break;)
   kappa 41 (    default:;)
   kappa 41 (})




   saveold

   kappa  (

#endif
